package de.uni_passau.fim.PADAS.group3.DataDash.Dataset;

import java.util.Optional;
import java.util.UUID;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import de.uni_passau.fim.PADAS.group3.DataDash.category.Category;

public interface DatasetRepository extends JpaRepository<Dataset, UUID> {
    Dataset getDatasetById(UUID id);

    @SuppressWarnings("null")
    Page<Dataset> findAll(Pageable pageable);

    @Query("""
        SELECT d FROM Dataset d WHERE
        (COALESCE(:title, '') = '' OR d.title LIKE :title) AND
        (COALESCE(:description, '') = '' OR d.description LIKE :description) AND
        (COALESCE(:author, '') = '' OR d.author LIKE :author) AND
        (COALESCE(:summary, '') = '' OR d.summary LIKE :summary) AND
        (:type IS NULL OR d.type = :type) AND
        (:category IS NULL OR d.category = :category) AND
        (:rating IS NULL OR d.rating > :rating)
        """)
    Page<Dataset> findByOptionalCriteria(
        @Param("title") Optional<String> title,
        @Param("description") Optional<String> description,
        @Param("author") Optional<String> author,
        @Param("summary") Optional<String> summary,
        @Param("type") Optional<Type> type,
        @Param("category") Optional<Category> categories,
        @Param("rating") Optional<Float> rating,
        Pageable pageable
    );

    @Query("""
        SELECT d FROM Dataset d WHERE
        ((LOWER(d.title) LIKE LOWER(:search)) OR
        (LOWER(d.description) LIKE LOWER(:search)) OR
        (LOWER(d.author) LIKE LOWER(:search))) AND
        (d.category = :category) AND
        (:type IS NULL OR d.type = :type)
        """)
    Page<Dataset> searchByOptionalCriteriaWithCategory(
        @Param("search") Optional<String> search,
        @Param("category") Category categories,
        @Param("type") Optional<Type> type,
        Pageable pageable
    );

    @Query("""
        SELECT d FROM Dataset d WHERE
        ((LOWER(d.title) LIKE LOWER(:search)) OR
        (LOWER(d.description) LIKE LOWER(:search)) OR
        (LOWER(d.author) LIKE LOWER(:search))) AND
        (:type IS NULL OR d.type = :type)
        """)
    Page<Dataset> searchByOptionalCriteria(
        @Param("search") Optional<String> search,
        @Param("type") Optional<Type> type,
        Pageable pageable
    );
}
