package de.uni_passau.fim.PADAS.group3.DataDash.category;
import java.util.List;
import java.util.UUID;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@RestController
@RequestMapping("/api/v1/categories")
public class CategoryController {
    @Autowired
    private CategoryService categoryService;

    @GetMapping
    public List<CategoryDto> getMethodName() {
        return categoryService.getAllCategories() ;
    }

    @GetMapping("/id/{id}")
    public ResponseEntity<?> fetchCategoryById(@PathVariable("id") UUID id) {
        CategoryDto category = categoryService.getCategoryById(id);
        return category == null
            ? new ResponseEntity<>(HttpStatus.NOT_FOUND)
            :new ResponseEntity<>(category, HttpStatus.OK);
    }

    @ResponseStatus(HttpStatus.CREATED)
    @PostMapping
    public Category createCategory(@RequestBody CategoryDto dto) {
        return categoryService.addCategory(dto);        
    }    
}
