package de.uni_passau.fim.PADAS.group3.DataDash.category;

import org.springframework.stereotype.Service;
import java.util.List;
import java.util.UUID;

@Service
public class CategoryService {
    private CategoryRepository categoryRepository;

    CategoryService(CategoryRepository categoryRepository) {
        this.categoryRepository = categoryRepository;
    }

    Category addCategory(CategoryDto category) {
        Category cat = new Category(category.getName());
        return categoryRepository.save(cat);
    }

    List<CategoryDto> getAllCategories() {
        List<Category> tmp = categoryRepository.findAll();
        List<CategoryDto> s = tmp.stream().map(CategoryDtoMapper::toDto).toList();
        return s;
    }

    CategoryDto getCategoryById(UUID id) {
        Category c = categoryRepository.getCategoryById(id);
        return c == null ? null : CategoryDtoMapper.toDto(c);
    }
}
